/*
	Definitions local to mouse manager.

	Created by Adrian Robinson
*/

#include <sys/sys_msg.h>

#include "mm_msg.h"

#define MAX_CLIENTS		25


struct _event_list {
	struct _event_list *next;
	MMEvent node;
};


typedef struct _mouse_server {
	struct _mouse_server *next;

	/* ------ info about mouse server connection ----- */
	struct _mouse_ctrl *mc;
	pid_t  mproxy, vmproxy;

	nid_t nid;
	int connectCount;
} MouseServer;


typedef struct {
	/* -------- pointer to mouse server connection ------- */
	MouseServer *server;

	/* ------ event list ------- */
	struct _event_list *start;
	struct _event_list *end;
	unsigned eventCount;

	/* ------ info about registered client ------ */
	pid_t  pid;
	pid_t  eproxy;
	nid_t  nid;
} MouseClient;


typedef struct {
	int maxClients;
	int clientCount;

	/* ------- variable length, must be last in list ------- */
	MouseClient clients[1];
} MMStats;


typedef union {
	msg_t						type;
	struct _sysmsg_hdr			hdr;
	struct _mouseman_open		open;
	struct _mouseman_read		read;
	struct _mouseman_close		close;
} MouseManMsg;


typedef union {
	msg_t							status;
	struct _mouseman_query_reply	query;
	struct _mouseman_open_reply		open;
	struct _mouseman_read_reply		read;
	struct _mouseman_stats_reply	stats;
} MouseManReply;


extern MMStats far *eMMStats;


int findClient(pid_t pid, int unused, int proxy);
int addClient(pid_t pid, struct _mouseman_open *msg, int *handle);
int delClient(pid_t pid, int handle);

void addEvent(int handle);
int  readEvent(pid_t pid, int handle, struct _mouseman_read_reply *rply, size_t *size);
